/*************************************************************************
*
* Name    :	vsscanf_test.cpp
*
* Author  : Anuj Seth <anujseth@yahoo.com>
*
* Purpose : Test program for vsscanf.
*
*           This example is very simple just to prove that vsscanf works!
*           If you are looking for a vsscanf implementation for Windows
*           you know exactly why such a function is useful to you.
*    
*           Happy Coding!
* 
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/

#include "stdafx.h"
#include "vsscanf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

// ProcessNumEmailMsgs takes variable number of parameters and
// uses vsscanf to parse the parameters.
void ProcessNumEmailMsgs(char *input, char *format, ...)
{
	va_list argList;

	va_start(argList, format);
	vsscanf(input, format, argList);
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		int startMsg, endMsg, totalMsg;
		char *input = "Showing 1 - 10 of 100";
		char *format = "Showing %d - %d of %d";
		
		// Variable Number of parameters are passed to this 
		// function
		ProcessNumEmailMsgs(input, format, &startMsg, &endMsg, &totalMsg);

		printf("Input String: %s\n", input);
		printf("StartMsg    : %d\n", startMsg);
		printf("EndMsg      : %d\n", endMsg);
		printf("TotalMsg    : %d\n", totalMsg);
	}

	return nRetCode;
}
